import { ModelInstance, BaseProps, Optional, PropertiesType } from "./index";
export declare function createModelInstance<P, M extends ModelInstance<P>>(model: Model<P, M>, props: P & BaseProps): M;
export declare class Model<P, M extends ModelInstance<P>> {
    label: String;
    private relations;
    private modelInstanceClass;
    protected beforeCreate(props: P & BaseProps): P & BaseProps;
    protected afterCreate(instance: M): M;
    protected beforeFind(props?: Optional<PropertiesType<P & BaseProps>>): (Optional<PropertiesType<P & BaseProps>>) | null;
    protected afterFind(instance: M): M;
    protected beforeUpdate(props: Optional<PropertiesType<P & BaseProps>>, newProps: Optional<P>): {
        props: Optional<PropertiesType<P & BaseProps>>;
        newProps: Optional<P>;
    };
    protected afterUpdate(instance: M): M;
    constructor(label: string);
    create(props: P): Promise<M>;
    findByGuid(guid: string): Promise<M | null>;
    delete(props: Optional<PropertiesType<P & BaseProps>>, detach?: boolean): Promise<number>;
    find(props?: Optional<PropertiesType<P & BaseProps>>): Promise<M[]>;
    findOne(props?: Optional<PropertiesType<P & BaseProps>>): Promise<M | null>;
    update(props: Optional<PropertiesType<P & BaseProps>>, newProps: Optional<P>): Promise<M[]>;
}
